'use strict';

var _index = require('../index');

var _global = global,
    test = _global.test,
    expect = _global.expect; // import { formatConditionals, checkConditionals, defaultStates, supportedActions } from './index';

var oldStatesObjects = [{
  visible: {
    ':input[name="name"]': {
      value: true
    }
  }
}, {
  visible: {
    ':input[name="name"]': {
      value: true
    },
    ':input[name="last_name"]': {
      filled: true
    }
  }
}, {
  visible: [{
    ':input[name="name"]': {
      value: true
    }
  }, 'or', {
    ':input[name="last_name"]': {
      filled: true
    }
  }]
}, {
  visible: [{
    ':input[name="name"]': {
      value: true
    }
  }, 'or', {
    ':input[name="last_name"]': {
      filled: true
    }
  }],
  required: {
    ':input[name="last_name"]': {
      value: true
    }
  }
}];

var newStatesObjects = [[{
  action: 'visible',
  logic: 'and',
  conditions: [{
    key: 'name',
    condition: 'value',
    value: true
  }]
}], [{
  action: 'visible',
  logic: 'and',
  conditions: [{
    key: 'name',
    condition: 'value',
    value: true
  }, {
    key: 'last_name',
    condition: 'filled',
    value: true
  }]
}], [{
  action: 'visible',
  logic: 'or',
  conditions: [{
    key: 'name',
    condition: 'value',
    value: true
  }, {
    key: 'last_name',
    condition: 'filled',
    value: true
  }]
}], [{
  action: 'visible',
  logic: 'or',
  conditions: [{
    key: 'name',
    condition: 'value',
    value: true
  }, {
    key: 'last_name',
    condition: 'filled',
    value: true
  }]
}, {
  action: 'required',
  logic: 'and',
  conditions: [{
    key: 'last_name',
    condition: 'value',
    value: true
  }]
}]];

var _loop = function _loop(i, l) {
  test('Test formatting of conditionals: #' + (i + 1), function () {
    expect((0, _index.formatConditionals)(oldStatesObjects[i])).toEqual(newStatesObjects[i]);
  });
};

for (var i = 0, l = oldStatesObjects.length; i < l; i += 1) {
  _loop(i, l);
}